module OO
  module Errors
    class LicenceMissing < StandardError
      attr_reader :user_data, :licence_key

      def initialize(attrs = {})
        @user_data = attrs[:user_data]
        @licence_key = attrs.fetch(:licence_key)
        super(error_message)
      end

      private

      def error_message
        msg = "User "
        msg << "#{user_data} " unless user_data.nil?
        msg << "is missing permission '#{licence_key}'. " \
               'Therefore he is not allowed to perform this activity.'
      end
    end
  end
end
