module OO
  module LicenceCheckers
    def self.included(base)
      base.class_eval do
        def licensed?(attrs = {})
          user = attrs.fetch(:user, licence_checkers_default_user)
          key = attrs.fetch(:to, licence_checkers_default_key)
          user.licensed?(to: key)
        end

        def check_licence!(attrs = {})
          user = attrs.fetch(:user, licence_checkers_default_user)
          key = attrs.fetch(:to, licence_checkers_default_key)
          licence_missing_reaction.call(key, user) unless licensed?(user: user,
                                                                    to: key)
        end

        private

        def licence_checkers_default_user
          OO.configuration.licence_checkers_default_user.call(self)
        end

        def licence_checkers_default_key
          OO.configuration.licence_checkers_default_key.call(self)
        end

        def licence_missing_reaction
          OO.configuration.licence_missing_reaction
        end
      end
    end
  end
end
